/*!\file GetSolutionFromInputsx
 * \brief: update datasets using  parameter inputs
 */

#include "./GetSolutionFromInputsx.h"
#include "../../shared/shared.h"
#include "../../include/include.h"
#include "../../toolkits/toolkits.h"
#include "../../EnumDefinitions/EnumDefinitions.h"

void	GetSolutionFromInputsx( Vec* psolution, Elements* elements,Nodes* nodes, Vertices* vertices,Loads* loads, Materials* materials,  Parameters* parameters){

	/*intermediary: */
	int gsize;
	int i;
	Element* element=NULL;

	int configuration_type;

	/*output: */
	Vec solution=NULL;

	/*retrive parameters: */
	parameters->FindParam(&configuration_type,ConfigurationTypeEnum);

	/*Get size of vector: */
	gsize=nodes->NumberOfDofs(configuration_type);
	if (gsize==0) ISSMERROR("Allocating a Vec of size 0 as gsize=0 for configuration: %s",EnumToString(configuration_type));
	
	/*Initialize solution: */
	solution=NewVec(gsize);
	
	/*Go through elements and plug solution: */
	for (i=0;i<elements->Size();i++){
		element=(Element*)elements->GetObjectByOffset(i);
		element->GetSolutionFromInputs(solution);
	}

	/*Assemble vector: */
	VecAssemblyBegin(solution);
	VecAssemblyEnd(solution);

	/*Assign output pointers:*/
	*psolution=solution;

}
